---
product: "AG Grid"
title: "Column Headers - Custom Components"
description: "Create Custom Header Components for the JavaScript Table. Customise header templates, create inner header components, and implement full custom headers with sorting, filtering and menu support."
framework: javascript
version: "36.2.0"
related:
    - title: "Styling & Height"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers-styling/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Headers - Custom Components

The grid provides a default Header Component with sorting, filtering and menu functionality. There are three approaches to customising Column Headers:

- [Custom Template](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers-components/#custom-template) - Provide an HTML template to the default Header Component for simple layout changes while retaining built-in functionality.
- [Inner Header Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers-components/#inner-header-component) - Replace just the header name display with a custom component while keeping sorting, filtering and menu functionality.
- [Custom Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers-components/#custom-component) - Create a fully custom Header Component with complete control over rendering and behaviour.

## Custom Template

Provide an HTML template to the Provided Header Component for simple layout changes while retaining built-in sorting, filtering and menu functionality.

Set the template using `colDef.headerComponentParams`. Set on the `defaultColDef` grid option to set for all Columns.

```js
const gridOptions = {
    defaultColDef: {
        width: 100,
        headerComponentParams: {
            template:
                `<div class="ag-cell-label-container" role="presentation">
                  <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                  <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                  <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                    <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order"></span>
                    <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon"></span>
                    <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon"></span>
                    <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon"></span>
                    <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon"></span>
                    <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon"></span>
                    <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon"></span>
                    ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                    <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                  </div>
                </div>`
        }
    },

    // other grid options ...
}
```

The example below demonstrates a custom template. Note that specifying your own templates is compatible with other configurations:

- `suppressHeaderFilterButton` is specified in: **Athlete**, **Country**, **Date** and **Bronze** columns
- `sortable=false` is specified in: **Age**, **Year**, **Date**, **Sport**, **Silver** and **Total** columns
- **Gold** is the only column that doesn't have `sortable=false` or `suppressHeaderFilterButton`

#### Header template

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const columnDefs: ColDef[] = [
  {
    headerName: "Athlete Name",
    field: "athlete",
    suppressHeaderFilterButton: true,
  },
  { field: "age", sortable: false },
  { field: "country", suppressHeaderFilterButton: true },
  { field: "year", sortable: false },
  { field: "date", suppressHeaderFilterButton: true, sortable: false },
  { field: "sport", sortable: false },
  { field: "gold" },
  { field: "silver", sortable: false },
  { field: "bronze", suppressHeaderFilterButton: true },
  { field: "total", sortable: false },
  { field: "prevYearTotalDiff", sort: { type: "absolute", direction: null } },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: columnDefs,
  defaultColDef: {
    filter: true,
    width: 150,
    headerComponentParams: {
      template: `<div class="ag-cell-label-container" role="presentation">
                    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                        <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order ag-hidden"></span>
                        <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon ag-hidden"></span>
                        <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon ag-hidden"></span>
                        <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon ag-hidden"></span>
                        ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                        <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                    </div>
                </div>`,
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) =>
    gridApi!.setGridOption(
      "rowData",
      data.map((d) => ({
        ...d,
        prevYearTotalDiff: Math.floor((2 * window.agRandom() - 1) * d.total),
      })),
    ),
  );
```

[Live example: Header template](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-template/typescript/)

### Default Template

This is the default template used in AG Grid:

```html
<div class="ag-cell-label-container" role="presentation">
    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button" aria-hidden="true"></span>
    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button" aria-hidden="true"></span>
    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
        <span data-ref="eText" class="ag-header-cell-text"></span>
        <span data-ref="eFilter" class="ag-header-icon ag-header-label-icon ag-filter-icon" aria-hidden="true"></span>
        <span data-ref="eSortOrder" class="ag-header-icon ag-header-label-icon ag-sort-order" aria-hidden="true"></span>
        <span data-ref="eSortAsc" class="ag-header-icon ag-header-label-icon ag-sort-ascending-icon" aria-hidden="true"></span>
        <span data-ref="eSortDesc" class="ag-header-icon ag-header-label-icon ag-sort-descending-icon" aria-hidden="true"></span>
        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-descending-icon ag-hidden"></span>
        <span data-ref="eSortMixed" class="ag-header-icon ag-header-label-icon ag-sort-mixed-icon ag-hidden"></span>
        <span data-ref="eSortNone" class="ag-header-icon ag-header-label-icon ag-sort-none-icon" aria-hidden="true"></span>
    </div>
</div>
```

When you provide your own template, everything should work as expected as long as you re-use the same `data-ref` attribute names.

| Ref | Description |
| --- | --- |
| `eMenu` | The container where the column menu icon will appear to enable opening the column menu (in AG Grid Community, this is only used when `columnMenu = 'legacy'`). |
| `eFilterButton` | The container where the column filter icon will appear to enable opening the filter (not used when `columnMenu = 'legacy'`). |
| `eLabel` | The container where there is going to be an onClick mouse listener to trigger the sort. |
| `eText` | The text displayed on the column. |
| `eFilter` | The container with the icon that will appear if the user filters this column (only used when `columnMenu = 'legacy'` or `suppressHeaderFilterButton = true`). |
| `eSortOrder` | If multiple columns are sorted, this shows the index that represents the position of this column in the order. |
| `eSortAsc` | If the column is sorted ascending, this shows the ascending icon. |
| `eSortDesc` | If the column is sorted descending, this shows the descending icon. |
| `eSortAbsoluteAsc` | If the column is sorted absolute ascending, this shows the absolute ascending icon. |
| `eSortAbsoluteDesc` | If the column is sorted absolute descending, this shows the absolute descending icon. |
| `eSortMixed` | If the column has a mixed sort state (e.g. grouped data with differing sort directions), this shows the mixed sort icon. |
| `eSortNone` | If no sort is applied, this shows the no sort icon. Note this icon by default is empty. |

The `data-ref` parameters are used by the grid to identify elements to add functionality to. If you leave an element out of your template, the functionality will not be added. For example if you do not specify `eLabel` then the column will not react to click events for sorting.

> **Note**
>
> Templates are not meant to let you configure icons. If you are looking to change the icons, see [Custom Icons](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/custom-icons/) for more information.

## Inner Header Component

When using the Header Component, the `agColumnHeader` component will display the header name, adjacent to any configured menu, filter, and checkbox.

This text value can be overridden with a [Custom Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/components/) by setting the `innerHeaderComponent` and `innerHeaderComponentParams` properties on the `headerComponentParams` property. This is useful when you only need to implement a Component to customise the **Column Name** without having to reimplement the whole header functionality (sorting, filter, menu, etc...).

```js
colDef = {
    ...
    headerComponentParams : {
        innerHeaderComponent: MyInnerHeaderComponent,
        innerHeaderComponentParams: {
            currencySymbol: '£' // the pound symbol will be placed into params
        }
    }
}
```

#### Custom Inner Header Component

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomInnerHeader } from "./customInnerHeader";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
  {
    field: "age",
    sortable: false,
    headerComponentParams: {
      icon: "fa-user",
    },
  },
  { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
  { field: "year", sortable: false },
  { field: "date", suppressHeaderFilterButton: true },
  { field: "sport", sortable: false },
  {
    field: "gold",
    headerComponentParams: { icon: "fa-cog" },
    minWidth: 120,
  },
  { field: "silver", sortable: false },
  { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
  { field: "total", sortable: false },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
    headerComponentParams: {
      innerHeaderComponent: CustomInnerHeader,
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Custom Inner Header Component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/inner-header-component/typescript/)

Implement this interface to provide a custom inner header component.

### IInnerHeaderComponent

```ts

interface IInnerHeaderComponent&lt;TData = any, TContext = any, TParams extends Readonly<<span/>IHeaderParams<<span/>TData, TContext>> = IHeaderParams<<span/>TData, TContext>&gt; {
  // Return the DOM element of your component, this is what the grid puts into the DOM 
  getGui(): <a tabindex="0" href="https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement" target="_blank" rel="noreferrer">HTMLElement</a>;

  // Get the header to refresh. Gets called whenever Column Defs are updated. 
  refresh(params: IHeaderParams): boolean;

  // Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here 
  destroy?(): void;

  // The init(params) method is called on the component once. 
  init?(params: TParams): AgPromise<<span/>void>  |  void;

}
```

### IHeaderParams

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Custom Component

To use a fully customised Header Component, set `headerComponent` on the Column Definition to the custom component. See [Registering Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/components/) for an overview.

```js
// a list of column definitions
const colDefs = [

    // no Header Comp specified, uses the Provided Header Comp
    {headerName: "Athlete", field: "athlete"},
    {headerName: "Sport", field: "sport"},

    // uses Custom Header Comp
    {headerName: "Age", field: "age", headerComponent: MyHeaderComponent}
]
```

- Column moving and resizing works without custom logic.
- `suppressHeaderFilterButton=true` is used to suppress the filter menu.
- `sortable=false` is used to suppress sorting.
- The menu icon is configurable.

#### Header component

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomHeader } from "./customHeader";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
  {
    field: "age",
    sortable: false,
    headerComponentParams: { menuIcon: "fa-external-link-alt" },
  },
  { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
  { field: "year", sortable: false },
  { field: "date", suppressHeaderFilterButton: true },
  { field: "sport", sortable: false },
  {
    field: "gold",
    headerComponentParams: { menuIcon: "fa-cog" },
    minWidth: 120,
  },
  { field: "silver", sortable: false },
  { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
  { field: "total", sortable: false },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
    headerComponent: CustomHeader,
    headerComponentParams: {
      menuIcon: "fa-filter",
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Header component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component/typescript/)

The interface for a custom header component is:

```ts
interface IHeaderComp {
    // Optional method, gets called once with params
    init?(params: IHeaderParams): void;

    // Return the DOM element of your component, this is what the grid puts into the DOM
    // Can get called more than once
    getGui(): HTMLElement;

    // Gets called when a new Column Definition has been set for this header.
    // If you handle the refresh of your header return true otherwise return false
    // and the grid will re-create your header from scratch.
    refresh(params: IHeaderParams): boolean;

    // Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
    destroy?(): void;
}
```

The `init(params)` method takes a params object with the items listed below.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

### Responsibilities

The grid provides the following features that should not be implemented by Custom Header Components:

- [**Resizing:**](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-sizing/) When enabled, the grid will put an invisible widget to be grabbed by the mouse for resizing.
- [**Header Checkbox Selection:**](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-selection-multi-row/#selecting-all-rows) When enabled, the grid displays a checkbox for 'select all' in the header.
- **Column Moving** The grid will react to Column Dragging to reorder columns.

The Custom Header Component is responsible for the following:

- **Sorting:** You will need to process user interaction for sorting. The default grid component sorts when the user clicks the header with the mouse. You may also need to display icons as the sort state of the column changes.
- **Filtering:** You do not filter via the column (you filter from inside the menu), however you may need to display icons as the filter state of the column changes.
- **Menu:** If you want the user to be able to open the column menu, you will need to manage this user interaction. The default grid component provides a button for the user to click to show the menu.
- **Anything Else:** Whatever you want, you are probably creating a custom header to add your own functionality in.

### Sorting

How you interact with the user for sorting (e.g. listening for mouse clicks) is up to you. The grid helps you by providing column state and events for getting and setting the sort.

After the user requests a sort, you should call ONE of the following:

1. `params.progressSort(multiSort)`: Call this method to progress the sort on the column to the next stage. This uses the grid logic to determine the next sort stage (eg 'descending' normally follows 'ascending').
2. `params.setSort(direction, multiSort)`: If you don't want to use the grid's logic for working out the next sort state, use this to set the sort to a specific state.

```js
// option 1) tell the grid when you want to progress the sorting
myHeaderElement.addEventListener('click', function(event) {
    // in this example, we do multi sort if Shift key is pressed
    params.progressSort(event.shiftKey);
});

// or option 2) tell the grid when you want to set the sort explicitly
// button that always sorts ASCENDING
mySortAscButton.addEventListener('click', function(event) {
    params.setSort('asc', event.shiftKey);
});

// button that always sorts DESCENDING
mySortDescButton.addEventListener('click', function(event) {
    params.setSort('desc', event.shiftKey);
});
```

To know when a column's sort state has changed (e.g. when to update your icons), you should listen for the `sortChanged` event on the column.

```js
// listen to the column for sort events
column.addEventListener('sortChanged', function() {

    // get sort state from column
    var sort = column.getSortDef()?.direction;
    console.log('sort state of column is ' + sort); // prints one of ['asc',desc',null]

    // then do what you need, e.g. set relevant icons visible
    var sortingAscending = sort==='asc';
    var sortingDescending = sort==='desc';
    var notSorting = !sortingAscending && !sortingDescending;
    // how you update your GUI accordingly is up to you
});

// don't forget to remove your listener in your destroy code
```

### Filtering

The header doesn't normally initiate filtering. If it does, use the standard grid API to set the filter. The header will typically display icons when the filter is applied. To know when to show a filter icon, listen to the column for `filterChanged` events.

```js
// listen to the column for filter events
column.addEventListener('filterChanged', function() {
    // when filter changes on the col, this will print one of [true,false]
    console.log('filter of column is ' + column.isFilterActive());
});

// don't forget to remove your listener in your destroy code
```

### Menu

How you get the user to ask for the column menu is up to you. When you want to display the menu, call the `params.showColumnMenu()` callback. The callback takes the HTML element for the button so that it can place the menu over the button (so the menu appears to drop down from the button).

```js
myMenuButton.addEventListener('click', function() {
    params.showColumnMenu(myMenuButton);
});
```

### Refreshing Headers

If you are creating your own [Header Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers/) then you will need to be aware of how Header Components are refreshed.

All Header Components that still exist after the new Column Definitions are applied (in other words, the Column still exists after the update, it was not removed) will have its `refresh` method called.

It is the responsibility of the Header Component to inspect the Column Definition for relevant changes and update itself if needed. If the refresh was successful then `true` should be returned. If the refresh was not successful then `false` should be returned. If `false` is returned, then the grid will destroy and recreate the component. This pattern is consistent with the `refresh` method of Cell Renderers.

The example below demonstrates refreshing of the headers. Note the following:

- Each column is configured to use a custom Header Component.
- The Header Component logs to the console when its lifecycle methods/functions are called.
- Toggling between 'Upper Header Names' and 'Lower Header Names' causes the Header Component to refresh.
- Toggling between 'Filter On' and 'Filter Off' causes the Header Component to refresh.
- Toggling between 'Resize On' and 'Resize Off' causes the Header Component to refresh. However there is no change to the Header Component as it doesn't depend on resize - the resize UI is provided by the grid.

#### Refresh Headers

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomHeader } from "./customHeader";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    headerComponent: CustomHeader,
  },
};

function onBtUpperNames() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.headerName = c.field!.toUpperCase();
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

function onBtLowerNames() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.headerName = c.field;
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

function onBtFilterOn() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.filter = true;
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

function onBtFilterOff() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.filter = false;
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

function onBtResizeOn() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.resizable = true;
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

function onBtResizeOff() {
  const columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  columnDefs.forEach((c) => {
    c.resizable = false;
  });
  gridApi!.setGridOption("columnDefs", columnDefs);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then(function (data) {
    gridApi!.setGridOption("rowData", data);
  });

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtUpperNames = onBtUpperNames;
  (<any>window).onBtLowerNames = onBtLowerNames;
  (<any>window).onBtFilterOn = onBtFilterOn;
  (<any>window).onBtFilterOff = onBtFilterOff;
  (<any>window).onBtResizeOn = onBtResizeOn;
  (<any>window).onBtResizeOff = onBtResizeOff;
}
```

[Live example: Refresh Headers](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/refresh-headers/typescript/)

### Custom Props

On top of the props provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the header component. For example, you might have a header component for formatting currency which also requires the currency symbol to be provided.

```js
colDef = {
    ...
    headerComponent: MyHeaderComponent;
    headerComponentParams : {
        currencySymbol: '£' // the pound symbol will be placed into params
    }
}
```

### Keyboard Navigation

When using Custom Header Components, the Custom Header Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid header with a Custom Header Component will focus the entire cell instead of any of the elements inside.

Adding support for keyboard navigation and focus requires a custom `suppressHeaderKeyboardEvent` function in grid options. See [Suppress Keyboard Events](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/keyboard-navigation/#suppress-keyboard-events).

An example of this is shown below, enabling keyboard navigation through the custom header elements when pressing `⇥ Tab` and `⇧ Shift`+`⇥ Tab`:

- Click on the top left `Athlete` header, press the `⇥ Tab` key and notice that the button, textbox and link in the `Country` header can be tabbed into. At the end of the cell elements, the tab focus moves to the next `Age` header cell
- Use `⇧ Shift`+`⇥ Tab` to navigate in the reverse direction

The `suppressHeaderKeyboardEvent` callback is used to capture tab events and determine if the user is tabbing forward or backwards. It also suppresses the default behaviour of moving to the next cell if tabbing within the child elements.

If the focus is at the beginning or the end of the cell children and moving out of the cell, the keyboard event is not suppressed, so focus can move between the children elements. Also, when moving backwards, the focus needs to be manually set while preventing the default behaviour of the keyboard press event.

#### Custom Header Keyboard Navigation

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SuppressHeaderKeyboardEventParams,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomHeader } from "./customHeader";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([TextFilterModule, ClientSideRowModelModule]);

const GRID_CELL_CLASSNAME = "ag-header-cell";

function getAllFocusableElementsOf(el: HTMLElement) {
  return Array.from<HTMLElement>(
    el.querySelectorAll(
      'button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"])',
    ),
  ).filter((focusableEl) => {
    return focusableEl.tabIndex !== -1;
  });
}

function getEventPath(event: Event): HTMLElement[] {
  const path: HTMLElement[] = [];
  let currentTarget: any = event.target;

  while (currentTarget) {
    path.push(currentTarget);
    currentTarget = currentTarget.parentElement;
  }

  return path;
}

/**
 * Capture whether the user is tabbing forwards or backwards and suppress keyboard event if tabbing
 * outside of the children
 */
function suppressHeaderKeyboardEvent({
  event,
}: SuppressHeaderKeyboardEventParams<any>) {
  const { key, shiftKey } = event;
  const path = getEventPath(event);
  const isTabForward = key === "Tab" && shiftKey === false;
  const isTabBackward = key === "Tab" && shiftKey === true;

  let suppressEvent = false;

  // Handle cell children tabbing
  if (isTabForward || isTabBackward) {
    const eGridCell = path.find((el) => {
      if (el.classList === undefined) return false;
      return el.classList.contains(GRID_CELL_CLASSNAME);
    });

    if (!eGridCell) {
      return suppressEvent;
    }

    const focusableChildrenElements = getAllFocusableElementsOf(eGridCell);
    const lastCellChildEl =
      focusableChildrenElements[focusableChildrenElements.length - 1];
    const firstCellChildEl = focusableChildrenElements[0];

    // Suppress keyboard event if tabbing forward within the cell and the current focused element is not the last child
    if (isTabForward && focusableChildrenElements.length > 0) {
      const isLastChildFocused =
        lastCellChildEl && document.activeElement === lastCellChildEl;
      if (!isLastChildFocused) {
        suppressEvent = true;
      }
    }
    // Suppress keyboard event if tabbing backwards within the cell, and the current focused element is not the first child
    else if (isTabBackward && focusableChildrenElements.length > 0) {
      const cellHasFocusedChildren =
        eGridCell.contains(document.activeElement) &&
        eGridCell !== document.activeElement;

      // Manually set focus to the last child element if cell doesn't have focused children
      if (!cellHasFocusedChildren) {
        lastCellChildEl.focus();
        // Cancel keyboard press, so that it doesn't focus on the last child and then pass through the keyboard press to
        // move to the 2nd last child element
        event.preventDefault();
      }

      const isFirstChildFocused =
        firstCellChildEl && document.activeElement === firstCellChildEl;
      if (!isFirstChildFocused) {
        suppressEvent = true;
      }
    }
  }

  return suppressEvent;
}

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    sortable: false,
  },
  {
    field: "country",
    headerComponent: CustomHeader,
    minWidth: 270,
    flex: 1,
    sortable: false,
  },
  {
    field: "age",
    sortable: false,
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs,
  defaultColDef: {
    minWidth: 130,
    flex: 1,
    suppressHeaderKeyboardEvent,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Custom Header Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component-keyboard-navigation/typescript/)

### Dynamic Tooltips

When using Custom Header Components it might be necessary to have a better control of how `Tooltips` are added instead of simply using the `headerTooltip` config. For this purpose, we provide the `setTooltip` method.

Properties available on the `IHeaderParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `setTooltip` | `Function` |  |  |  |

The example below demonstrates using the Dynamic Tooltips with a Custom Header Component.

- Note that only Column Headers where the text is not fully displayed will show tooltips.

#### Header Tooltip

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  TooltipModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CustomHeader } from "./customHeader";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  TooltipModule,
]);

const columnDefs: ColDef[] = [
  {
    field: "athlete",
    headerName: "Athlete's Full Name",
    suppressHeaderFilterButton: true,
    minWidth: 120,
  },
  {
    field: "age",
    headerName: "Athlete's Age",
    sortable: false,
    headerComponentParams: { menuIcon: "fa-external-link-alt" },
  },
  {
    field: "country",
    headerName: "Athlete's Country",
    suppressHeaderFilterButton: true,
    minWidth: 120,
  },
  { field: "year", headerName: "Event Year", sortable: false },
  { field: "date", headerName: "Event Date", suppressHeaderFilterButton: true },
  { field: "sport", sortable: false },
  {
    field: "gold",
    headerName: "Gold Medals",
    headerComponentParams: { menuIcon: "fa-cog" },
    minWidth: 120,
  },
  { field: "silver", headerName: "Silver Medals", sortable: false },
  {
    field: "bronze",
    headerName: "Bronze Medals",
    suppressHeaderFilterButton: true,
    minWidth: 120,
  },
  { field: "total", headerName: "Total Medals", sortable: false },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: columnDefs,
  defaultColDef: {
    editable: true,
    filter: true,
    width: 120,
    headerComponent: CustomHeader,
    headerComponentParams: {
      menuIcon: "fa-bars",
    },
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => {
    gridApi!.setGridOption("rowData", data);
  });
```

[Live example: Header Tooltip](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/dynamic-tooltips/typescript/)

### Touch Support

See the [Touch](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/touch/) documentation for how the grid will handle touch support, particularly for [Touch Events](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/touch/#custom-header-components).


---
product: "AG Grid"
title: "Column Headers - Custom Components"
description: "Create Custom Header Components for the Angular Table. Customise header templates, create inner header components, and implement full custom headers with sorting, filtering and menu support."
framework: angular
version: "36.2.0"
related:
    - title: "Styling & Height"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers-styling/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Headers - Custom Components

The grid provides a default Header Component with sorting, filtering and menu functionality. There are three approaches to customising Column Headers:

- [Custom Template](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers-components/#custom-template) - Provide an HTML template to the default Header Component for simple layout changes while retaining built-in functionality.
- [Inner Header Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers-components/#inner-header-component) - Replace just the header name display with a custom component while keeping sorting, filtering and menu functionality.
- [Custom Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers-components/#custom-component) - Create a fully custom Header Component with complete control over rendering and behaviour.

## Custom Template

Provide an HTML template to the Provided Header Component for simple layout changes while retaining built-in sorting, filtering and menu functionality.

Set the template using `colDef.headerComponentParams`. Set on the `defaultColDef` grid option to set for all Columns.

```ts
<ag-grid-angular
    [defaultColDef]="defaultColDef"
    /* other grid options ... */ />

this.defaultColDef = {
    width: 100,
    headerComponentParams: {
        template:
            `<div class="ag-cell-label-container" role="presentation">
              <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
              <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
              <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order"></span>
                <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon"></span>
                <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon"></span>
                <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon"></span>
                <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon"></span>
                <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon"></span>
                <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon"></span>
                ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
              </div>
            </div>`
    }
};
```

The example below demonstrates a custom template. Note that specifying your own templates is compatible with other configurations:

- `suppressHeaderFilterButton` is specified in: **Athlete**, **Country**, **Date** and **Bronze** columns
- `sortable=false` is specified in: **Age**, **Year**, **Date**, **Sport**, **Silver** and **Total** columns
- **Gold** is the only column that doesn't have `sortable=false` or `suppressHeaderFilterButton`

#### Header template

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      headerName: "Athlete Name",
      field: "athlete",
      suppressHeaderFilterButton: true,
    },
    { field: "age", sortable: false },
    { field: "country", suppressHeaderFilterButton: true },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true, sortable: false },
    { field: "sport", sortable: false },
    { field: "gold" },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true },
    { field: "total", sortable: false },
    { field: "prevYearTotalDiff", sort: { type: "absolute", direction: null } },
  ];
  defaultColDef: ColDef = {
    filter: true,
    width: 150,
    headerComponentParams: {
      template: `<div class="ag-cell-label-container" role="presentation">
                    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                        <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order ag-hidden"></span>
                        <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon ag-hidden"></span>
                        <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon ag-hidden"></span>
                        <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon ag-hidden"></span>
                        ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                        <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                    </div>
                </div>`,
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe(
        (data) =>
          (this.rowData = data.map((d) => ({
            ...d,
            prevYearTotalDiff: Math.floor(
              (2 * window.agRandom() - 1) * d.total,
            ),
          }))),
      );
  }
}
```

[Live example: Header template](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-template/angular/)

### Default Template

This is the default template used in AG Grid:

```html
<div class="ag-cell-label-container" role="presentation">
    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button" aria-hidden="true"></span>
    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button" aria-hidden="true"></span>
    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
        <span data-ref="eText" class="ag-header-cell-text"></span>
        <span data-ref="eFilter" class="ag-header-icon ag-header-label-icon ag-filter-icon" aria-hidden="true"></span>
        <span data-ref="eSortOrder" class="ag-header-icon ag-header-label-icon ag-sort-order" aria-hidden="true"></span>
        <span data-ref="eSortAsc" class="ag-header-icon ag-header-label-icon ag-sort-ascending-icon" aria-hidden="true"></span>
        <span data-ref="eSortDesc" class="ag-header-icon ag-header-label-icon ag-sort-descending-icon" aria-hidden="true"></span>
        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-descending-icon ag-hidden"></span>
        <span data-ref="eSortMixed" class="ag-header-icon ag-header-label-icon ag-sort-mixed-icon ag-hidden"></span>
        <span data-ref="eSortNone" class="ag-header-icon ag-header-label-icon ag-sort-none-icon" aria-hidden="true"></span>
    </div>
</div>
```

When you provide your own template, everything should work as expected as long as you re-use the same `data-ref` attribute names.

| Ref | Description |
| --- | --- |
| `eMenu` | The container where the column menu icon will appear to enable opening the column menu (in AG Grid Community, this is only used when `columnMenu = 'legacy'`). |
| `eFilterButton` | The container where the column filter icon will appear to enable opening the filter (not used when `columnMenu = 'legacy'`). |
| `eLabel` | The container where there is going to be an onClick mouse listener to trigger the sort. |
| `eText` | The text displayed on the column. |
| `eFilter` | The container with the icon that will appear if the user filters this column (only used when `columnMenu = 'legacy'` or `suppressHeaderFilterButton = true`). |
| `eSortOrder` | If multiple columns are sorted, this shows the index that represents the position of this column in the order. |
| `eSortAsc` | If the column is sorted ascending, this shows the ascending icon. |
| `eSortDesc` | If the column is sorted descending, this shows the descending icon. |
| `eSortAbsoluteAsc` | If the column is sorted absolute ascending, this shows the absolute ascending icon. |
| `eSortAbsoluteDesc` | If the column is sorted absolute descending, this shows the absolute descending icon. |
| `eSortMixed` | If the column has a mixed sort state (e.g. grouped data with differing sort directions), this shows the mixed sort icon. |
| `eSortNone` | If no sort is applied, this shows the no sort icon. Note this icon by default is empty. |

The `data-ref` parameters are used by the grid to identify elements to add functionality to. If you leave an element out of your template, the functionality will not be added. For example if you do not specify `eLabel` then the column will not react to click events for sorting.

> **Note**
>
> Templates are not meant to let you configure icons. If you are looking to change the icons, see [Custom Icons](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/custom-icons/) for more information.

## Inner Header Component

When using the Header Component, the `agColumnHeader` component will display the header name, adjacent to any configured menu, filter, and checkbox.

This text value can be overridden with a [Custom Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/components/) by setting the `innerHeaderComponent` and `innerHeaderComponentParams` properties on the `headerComponentParams` property. This is useful when you only need to implement a Component to customise the **Column Name** without having to reimplement the whole header functionality (sorting, filter, menu, etc...).

```js
colDef = {
    ...
    headerComponentParams : {
        innerHeaderComponent: MyInnerHeaderComponent,
        innerHeaderComponentParams: {
            currencySymbol: '£' // the pound symbol will be placed into params
        }
    }
}
```

#### Custom Inner Header Component

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);
import { CustomInnerHeader } from "./custom-inner-header.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomInnerHeader],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
    {
      field: "age",
      sortable: false,
      headerComponentParams: {
        icon: "fa-user",
      },
    },
    { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerComponentParams: { icon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "total", sortable: false },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
    headerComponentParams: {
      innerHeaderComponent: CustomInnerHeader,
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Custom Inner Header Component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/inner-header-component/angular/)

Implement this interface to provide a custom inner header component.

### IInnerHeaderAngularComp

```ts

interface IInnerHeaderAngularComp {
  // Mandatory - Params for rendering this component. 
  agInit(params: IHeaderParams): void;

  // Get the header to refresh. Gets called whenever Column Defs are updated. 
  refresh(params: IHeaderParams): boolean;

}
```

### IHeaderParams

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Custom Component

To use a fully customised Header Component, set `headerComponent` on the Column Definition to the custom component. See [Registering Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/components/) for an overview.

```js
// a list of column definitions
const colDefs = [

    // no Header Comp specified, uses the Provided Header Comp
    {headerName: "Athlete", field: "athlete"},
    {headerName: "Sport", field: "sport"},

    // uses Custom Header Comp
    {headerName: "Age", field: "age", headerComponent: MyHeaderComponent}
]
```

- Column moving and resizing works without custom logic.
- `suppressHeaderFilterButton=true` is used to suppress the filter menu.
- `sortable=false` is used to suppress sorting.
- The menu icon is configurable.

#### Header component

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);
import { CustomHeader } from "./custom-header.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomHeader],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
    {
      field: "age",
      sortable: false,
      headerComponentParams: { menuIcon: "fa-external-link-alt" },
    },
    { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerComponentParams: { menuIcon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "total", sortable: false },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    filter: true,
    headerComponent: CustomHeader,
    headerComponentParams: {
      menuIcon: "fa-filter",
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Header component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component/angular/)

The interface for a custom header component is:

```js
interface IHeaderAngularComp {
    // The agInit(params) method is called on the header component once.
    // See below for details on the parameters.
    agInit(params: IHeaderParams): void;

    // Gets called when a new Column Definition has been set for this header.
    // If you handle the refresh of your header return true otherwise return false
    // and the grid will re-create your header from scratch.
    refresh(params: IHeaderParams): boolean;
}
```

The `agInit(params)` method takes a params object with the items listed below.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

### Responsibilities

The grid provides the following features that should not be implemented by Custom Header Components:

- [**Resizing:**](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-sizing/) When enabled, the grid will put an invisible widget to be grabbed by the mouse for resizing.
- [**Header Checkbox Selection:**](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-selection-multi-row/#selecting-all-rows) When enabled, the grid displays a checkbox for 'select all' in the header.
- **Column Moving** The grid will react to Column Dragging to reorder columns.

The Custom Header Component is responsible for the following:

- **Sorting:** You will need to process user interaction for sorting. The default grid component sorts when the user clicks the header with the mouse. You may also need to display icons as the sort state of the column changes.
- **Filtering:** You do not filter via the column (you filter from inside the menu), however you may need to display icons as the filter state of the column changes.
- **Menu:** If you want the user to be able to open the column menu, you will need to manage this user interaction. The default grid component provides a button for the user to click to show the menu.
- **Anything Else:** Whatever you want, you are probably creating a custom header to add your own functionality in.

### Sorting

How you interact with the user for sorting (e.g. listening for mouse clicks) is up to you. The grid helps you by providing column state and events for getting and setting the sort.

After the user requests a sort, you should call ONE of the following:

1. `params.progressSort(multiSort)`: Call this method to progress the sort on the column to the next stage. This uses the grid logic to determine the next sort stage (eg 'descending' normally follows 'ascending').
2. `params.setSort(direction, multiSort)`: If you don't want to use the grid's logic for working out the next sort state, use this to set the sort to a specific state.

```js
// option 1) tell the grid when you want to progress the sorting
onSortClicked(event) {
     // in this example, we do multi sort if Shift key is pressed
    this.params.progressSort(event.shiftKey);
};

// or option 2) tell the grid when you want to set the sort explicitly
// button that always sorts ASCENDING
onSortAscClicked(event) {
    this.params.setSort('asc', event.shiftKey);
};

// button that always sorts DESCENDING
onSortDescClicked(event) {
    this.params.setSort('desc', event.shiftKey);
};
```

To know when a column's sort state has changed (e.g. when to update your icons), you should listen for the `sortChanged` event on the column.

```js
// listen to the column for sort events
column.addEventListener('sortChanged', function() {

    // get sort state from column
    var sort = column.getSortDef()?.direction;
    console.log('sort state of column is ' + sort); // prints one of ['asc',desc',null]

    // then do what you need, e.g. set relevant icons visible
    var sortingAscending = sort==='asc';
    var sortingDescending = sort==='desc';
    var notSorting = !sortingAscending && !sortingDescending;
    // how you update your GUI accordingly is up to you
});

// don't forget to remove your listener in your destroy code
```

### Filtering

The header doesn't normally initiate filtering. If it does, use the standard grid API to set the filter. The header will typically display icons when the filter is applied. To know when to show a filter icon, listen to the column for `filterChanged` events.

```js
// listen to the column for filter events
column.addEventListener('filterChanged', function() {
    // when filter changes on the col, this will print one of [true,false]
    console.log('filter of column is ' + column.isFilterActive());
});

// don't forget to remove your listener in your destroy code
```

### Menu

How you get the user to ask for the column menu is up to you. When you want to display the menu, call the `params.showColumnMenu()` callback. The callback takes the HTML element for the button so that it can place the menu over the button (so the menu appears to drop down from the button).

```js
onMenuClicked() {
    this.params.showColumnMenu(this.menuButton.nativeElement);
});
```

### Refreshing Headers

If you are creating your own [Header Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers/) then you will need to be aware of how Header Components are refreshed.

All Header Components that still exist after the new Column Definitions are applied (in other words, the Column still exists after the update, it was not removed) will have its `refresh` method called.

It is the responsibility of the Header Component to inspect the Column Definition for relevant changes and update itself if needed. If the refresh was successful then `true` should be returned. If the refresh was not successful then `false` should be returned. If `false` is returned, then the grid will destroy and recreate the component. This pattern is consistent with the `refresh` method of Cell Renderers.

The example below demonstrates refreshing of the headers. Note the following:

- Each column is configured to use a custom Header Component.
- The Header Component logs to the console when its lifecycle methods/functions are called.
- Toggling between 'Upper Header Names' and 'Lower Header Names' causes the Header Component to refresh.
- Toggling between 'Filter On' and 'Filter Off' causes the Header Component to refresh.
- Toggling between 'Resize On' and 'Resize Off' causes the Header Component to refresh. However there is no change to the Header Component as it doesn't depend on resize - the resize UI is provided by the grid.

#### Refresh Headers

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);
import { CustomHeader } from "./custom-header.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomHeader],
  template: `<div class="test-container">
    <div class="test-header">
      <button (click)="onBtUpperNames()">Upper Header Names</button>
      <button (click)="onBtLowerNames()">Lower Header Names</button>
      &nbsp;&nbsp;&nbsp;
      <button (click)="onBtFilterOn()">Filter On</button>
      <button (click)="onBtFilterOff()">Filter Off</button>
      &nbsp;&nbsp;&nbsp;
      <button (click)="onBtResizeOn()">Resize On</button>
      <button (click)="onBtResizeOff()">Resize Off</button>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      class="test-grid"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    headerComponent: CustomHeader,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtUpperNames() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.headerName = c.field!.toUpperCase();
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onBtLowerNames() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.headerName = c.field;
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onBtFilterOn() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.filter = true;
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onBtFilterOff() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.filter = false;
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onBtResizeOn() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.resizable = true;
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onBtResizeOff() {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.resizable = false;
    });
    this.gridApi.setGridOption("columnDefs", columnDefs);
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Refresh Headers](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/refresh-headers/angular/)

### Custom Props

On top of the props provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the header component. For example, you might have a header component for formatting currency which also requires the currency symbol to be provided.

```js
colDef = {
    ...
    headerComponent: MyHeaderComponent;
    headerComponentParams : {
        currencySymbol: '£' // the pound symbol will be placed into params
    }
}
```

### Keyboard Navigation

When using Custom Header Components, the Custom Header Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid header with a Custom Header Component will focus the entire cell instead of any of the elements inside.

Adding support for keyboard navigation and focus requires a custom `suppressHeaderKeyboardEvent` function in grid options. See [Suppress Keyboard Events](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/keyboard-navigation/#suppress-keyboard-events).

An example of this is shown below, enabling keyboard navigation through the custom header elements when pressing `⇥ Tab` and `⇧ Shift`+`⇥ Tab`:

- Click on the top left `Athlete` header, press the `⇥ Tab` key and notice that the button, textbox and link in the `Country` header can be tabbed into. At the end of the cell elements, the tab focus moves to the next `Age` header cell
- Use `⇧ Shift`+`⇥ Tab` to navigate in the reverse direction

The `suppressHeaderKeyboardEvent` callback is used to capture tab events and determine if the user is tabbing forward or backwards. It also suppresses the default behaviour of moving to the next cell if tabbing within the child elements.

If the focus is at the beginning or the end of the cell children and moving out of the cell, the keyboard event is not suppressed, so focus can move between the children elements. Also, when moving backwards, the focus needs to be manually set while preventing the default behaviour of the keyboard press event.

#### Custom Header Keyboard Navigation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SuppressHeaderKeyboardEventParams,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([TextFilterModule, ClientSideRowModelModule]);
import { CustomHeader } from "./custom-header.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomHeader],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      sortable: false,
    },
    {
      field: "country",
      headerComponent: CustomHeader,
      minWidth: 270,
      flex: 1,
      sortable: false,
    },
    {
      field: "age",
      sortable: false,
    },
  ];
  defaultColDef: ColDef = {
    minWidth: 130,
    flex: 1,
    suppressHeaderKeyboardEvent,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}

const GRID_CELL_CLASSNAME = "ag-header-cell";
function getAllFocusableElementsOf(el: HTMLElement) {
  return Array.from<HTMLElement>(
    el.querySelectorAll(
      'button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"])',
    ),
  ).filter((focusableEl) => {
    return focusableEl.tabIndex !== -1;
  });
}
function getEventPath(event: Event): HTMLElement[] {
  const path: HTMLElement[] = [];
  let currentTarget: any = event.target;
  while (currentTarget) {
    path.push(currentTarget);
    currentTarget = currentTarget.parentElement;
  }
  return path;
}
/**
 * Capture whether the user is tabbing forwards or backwards and suppress keyboard event if tabbing
 * outside of the children
 */
function suppressHeaderKeyboardEvent({
  event,
}: SuppressHeaderKeyboardEventParams) {
  const { key, shiftKey } = event;
  const path = getEventPath(event);
  const isTabForward = key === "Tab" && shiftKey === false;
  const isTabBackward = key === "Tab" && shiftKey === true;
  let suppressEvent = false;
  // Handle cell children tabbing
  if (isTabForward || isTabBackward) {
    const eGridCell = path.find((el) => {
      if (el.classList === undefined) return false;
      return el.classList.contains(GRID_CELL_CLASSNAME);
    });
    if (!eGridCell) {
      return suppressEvent;
    }
    const focusableChildrenElements = getAllFocusableElementsOf(eGridCell);
    const lastCellChildEl =
      focusableChildrenElements[focusableChildrenElements.length - 1];
    const firstCellChildEl = focusableChildrenElements[0];
    // Suppress keyboard event if tabbing forward within the cell and the current focused element is not the last child
    if (isTabForward && focusableChildrenElements.length > 0) {
      const isLastChildFocused =
        lastCellChildEl && document.activeElement === lastCellChildEl;
      if (!isLastChildFocused) {
        suppressEvent = true;
      }
    }
    // Suppress keyboard event if tabbing backwards within the cell, and the current focused element is not the first child
    else if (isTabBackward && focusableChildrenElements.length > 0) {
      const cellHasFocusedChildren =
        eGridCell.contains(document.activeElement) &&
        eGridCell !== document.activeElement;
      // Manually set focus to the last child element if cell doesn't have focused children
      if (!cellHasFocusedChildren) {
        lastCellChildEl.focus();
        // Cancel keyboard press, so that it doesn't focus on the last child and then pass through the keyboard press to
        // move to the 2nd last child element
        event.preventDefault();
      }
      const isFirstChildFocused =
        firstCellChildEl && document.activeElement === firstCellChildEl;
      if (!isFirstChildFocused) {
        suppressEvent = true;
      }
    }
  }
  return suppressEvent;
}
```

[Live example: Custom Header Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component-keyboard-navigation/angular/)

### Dynamic Tooltips

When using Custom Header Components it might be necessary to have a better control of how `Tooltips` are added instead of simply using the `headerTooltip` config. For this purpose, we provide the `setTooltip` method.

Properties available on the `IHeaderParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `setTooltip` | `Function` |  |  |  |

The example below demonstrates using the Dynamic Tooltips with a Custom Header Component.

- Note that only Column Headers where the text is not fully displayed will show tooltips.

#### Header Tooltip

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  TooltipModule,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  TooltipModule,
]);
import { CustomHeader } from "./custom-header.component";
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, CustomHeader],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "athlete",
      headerName: "Athlete's Full Name",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    {
      field: "age",
      headerName: "Athlete's Age",
      sortable: false,
      headerComponentParams: { menuIcon: "fa-external-link-alt" },
    },
    {
      field: "country",
      headerName: "Athlete's Country",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    { field: "year", headerName: "Event Year", sortable: false },
    {
      field: "date",
      headerName: "Event Date",
      suppressHeaderFilterButton: true,
    },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerName: "Gold Medals",
      headerComponentParams: { menuIcon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", headerName: "Silver Medals", sortable: false },
    {
      field: "bronze",
      headerName: "Bronze Medals",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    { field: "total", headerName: "Total Medals", sortable: false },
  ];
  defaultColDef: ColDef = {
    editable: true,
    filter: true,
    width: 120,
    headerComponent: CustomHeader,
    headerComponentParams: {
      menuIcon: "fa-bars",
    },
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }
}
```

[Live example: Header Tooltip](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/dynamic-tooltips/angular/)

### Touch Support

See the [Touch](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/touch/) documentation for how the grid will handle touch support, particularly for [Touch Events](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/touch/#custom-header-components).


---
product: "AG Grid"
title: "Column Headers - Custom Components"
description: "Create Custom Header Components for the Vue Table. Customise header templates, create inner header components, and implement full custom headers with sorting, filtering and menu support."
framework: vue
version: "36.2.0"
related:
    - title: "Styling & Height"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers-styling/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Headers - Custom Components

The grid provides a default Header Component with sorting, filtering and menu functionality. There are three approaches to customising Column Headers:

- [Custom Template](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers-components/#custom-template) - Provide an HTML template to the default Header Component for simple layout changes while retaining built-in functionality.
- [Inner Header Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers-components/#inner-header-component) - Replace just the header name display with a custom component while keeping sorting, filtering and menu functionality.
- [Custom Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers-components/#custom-component) - Create a fully custom Header Component with complete control over rendering and behaviour.

## Custom Template

Provide an HTML template to the Provided Header Component for simple layout changes while retaining built-in sorting, filtering and menu functionality.

Set the template using `colDef.headerComponentParams`. Set on the `defaultColDef` grid option to set for all Columns.

```ts
<ag-grid-vue
    :defaultColDef="defaultColDef"
    /* other grid options ... */>
</ag-grid-vue>

this.defaultColDef = {
    width: 100,
    headerComponentParams: {
        template:
            `<div class="ag-cell-label-container" role="presentation">
              <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
              <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
              <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order"></span>
                <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon"></span>
                <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon"></span>
                <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon"></span>
                <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon"></span>
                <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon"></span>
                <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon"></span>
                ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
              </div>
            </div>`
    }
};
```

The example below demonstrates a custom template. Note that specifying your own templates is compatible with other configurations:

- `suppressHeaderFilterButton` is specified in: **Athlete**, **Country**, **Date** and **Bronze** columns
- `sortable=false` is specified in: **Age**, **Year**, **Date**, **Sport**, **Silver** and **Total** columns
- **Gold** is the only column that doesn't have `sortable=false` or `suppressHeaderFilterButton`

#### Header template

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        headerName: "Athlete Name",
        field: "athlete",
        suppressHeaderFilterButton: true,
      },
      { field: "age", sortable: false },
      { field: "country", suppressHeaderFilterButton: true },
      { field: "year", sortable: false },
      { field: "date", suppressHeaderFilterButton: true, sortable: false },
      { field: "sport", sortable: false },
      { field: "gold" },
      { field: "silver", sortable: false },
      { field: "bronze", suppressHeaderFilterButton: true },
      { field: "total", sortable: false },
      {
        field: "prevYearTotalDiff",
        sort: { type: "absolute", direction: null },
      },
    ]);
    const defaultColDef = ref<ColDef>({
      filter: true,
      width: 150,
      headerComponentParams: {
        template: `<div class="ag-cell-label-container" role="presentation">
                    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                        <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order ag-hidden"></span>
                        <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon ag-hidden"></span>
                        <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon ag-hidden"></span>
                        <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon ag-hidden"></span>
                        ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                        <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                    </div>
                </div>`,
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) =>
        (rowData.value = data.map((d) => ({
          ...d,
          prevYearTotalDiff: Math.floor((2 * window.agRandom() - 1) * d.total),
        })));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Header template](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-template/vue3/)

### Default Template

This is the default template used in AG Grid:

```html
<div class="ag-cell-label-container" role="presentation">
    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button" aria-hidden="true"></span>
    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button" aria-hidden="true"></span>
    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
        <span data-ref="eText" class="ag-header-cell-text"></span>
        <span data-ref="eFilter" class="ag-header-icon ag-header-label-icon ag-filter-icon" aria-hidden="true"></span>
        <span data-ref="eSortOrder" class="ag-header-icon ag-header-label-icon ag-sort-order" aria-hidden="true"></span>
        <span data-ref="eSortAsc" class="ag-header-icon ag-header-label-icon ag-sort-ascending-icon" aria-hidden="true"></span>
        <span data-ref="eSortDesc" class="ag-header-icon ag-header-label-icon ag-sort-descending-icon" aria-hidden="true"></span>
        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-descending-icon ag-hidden"></span>
        <span data-ref="eSortMixed" class="ag-header-icon ag-header-label-icon ag-sort-mixed-icon ag-hidden"></span>
        <span data-ref="eSortNone" class="ag-header-icon ag-header-label-icon ag-sort-none-icon" aria-hidden="true"></span>
    </div>
</div>
```

When you provide your own template, everything should work as expected as long as you re-use the same `data-ref` attribute names.

| Ref | Description |
| --- | --- |
| `eMenu` | The container where the column menu icon will appear to enable opening the column menu (in AG Grid Community, this is only used when `columnMenu = 'legacy'`). |
| `eFilterButton` | The container where the column filter icon will appear to enable opening the filter (not used when `columnMenu = 'legacy'`). |
| `eLabel` | The container where there is going to be an onClick mouse listener to trigger the sort. |
| `eText` | The text displayed on the column. |
| `eFilter` | The container with the icon that will appear if the user filters this column (only used when `columnMenu = 'legacy'` or `suppressHeaderFilterButton = true`). |
| `eSortOrder` | If multiple columns are sorted, this shows the index that represents the position of this column in the order. |
| `eSortAsc` | If the column is sorted ascending, this shows the ascending icon. |
| `eSortDesc` | If the column is sorted descending, this shows the descending icon. |
| `eSortAbsoluteAsc` | If the column is sorted absolute ascending, this shows the absolute ascending icon. |
| `eSortAbsoluteDesc` | If the column is sorted absolute descending, this shows the absolute descending icon. |
| `eSortMixed` | If the column has a mixed sort state (e.g. grouped data with differing sort directions), this shows the mixed sort icon. |
| `eSortNone` | If no sort is applied, this shows the no sort icon. Note this icon by default is empty. |

The `data-ref` parameters are used by the grid to identify elements to add functionality to. If you leave an element out of your template, the functionality will not be added. For example if you do not specify `eLabel` then the column will not react to click events for sorting.

> **Note**
>
> Templates are not meant to let you configure icons. If you are looking to change the icons, see [Custom Icons](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/custom-icons/) for more information.

## Inner Header Component

When using the Header Component, the `agColumnHeader` component will display the header name, adjacent to any configured menu, filter, and checkbox.

This text value can be overridden with a [Custom Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/components/) by setting the `innerHeaderComponent` and `innerHeaderComponentParams` properties on the `headerComponentParams` property. This is useful when you only need to implement a Component to customise the **Column Name** without having to reimplement the whole header functionality (sorting, filter, menu, etc...).

```js
colDef = {
    ...
        headerComponentParams : {
        innerHeaderComponent: 'MyInnerHeaderComponent',
        innerHeaderComponentParams: {
            currencySymbol: '£' // the pound symbol will be placed into params
        }
    }
}
```

#### Custom Inner Header Component

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomInnerHeader from "./customInnerHeaderVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomInnerHeader,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
      {
        field: "age",
        sortable: false,
        headerComponentParams: {
          icon: "fa-user",
        },
      },
      { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
      { field: "year", sortable: false },
      { field: "date", suppressHeaderFilterButton: true },
      { field: "sport", sortable: false },
      {
        field: "gold",
        headerComponentParams: { icon: "fa-cog" },
        minWidth: 120,
      },
      { field: "silver", sortable: false },
      { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
      { field: "total", sortable: false },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
      headerComponentParams: {
        innerHeaderComponent: "CustomInnerHeader",
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Inner Header Component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/inner-header-component/vue3/)

Any valid Vue component can be a custom inner header component, however it must implement the `IHeader` interface:

### IHeader

```ts

interface IHeader {
  // Get the header to refresh. Gets called whenever Column Defs are updated. 
  refresh(params: IHeaderParams): boolean;

}
```

## Custom Component

To use a fully customised Header Component, set `headerComponent` on the Column Definition to the custom component. See [Registering Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/components/) for an overview.

```js
// a list of column definitions
this.columnDefs = [

    // no Header Comp specified, uses the Provided Header Comp
    {headerName: "Athlete", field: "athlete"},
    {headerName: "Sport", field: "sport"},

    // uses Custom Header Comp
    {headerName: "Age", field: "age", headerComponent: 'myHeaderComponent'}
]
```

- Column moving and resizing works without custom logic.
- `suppressHeaderFilterButton=true` is used to suppress the filter menu.
- `sortable=false` is used to suppress sorting.
- The menu icon is configurable.

#### Header component

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeaderVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomHeader,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
      {
        field: "age",
        sortable: false,
        headerComponentParams: { menuIcon: "fa-external-link-alt" },
      },
      { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
      { field: "year", sortable: false },
      { field: "date", suppressHeaderFilterButton: true },
      { field: "sport", sortable: false },
      {
        field: "gold",
        headerComponentParams: { menuIcon: "fa-cog" },
        minWidth: 120,
      },
      { field: "silver", sortable: false },
      { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
      { field: "total", sortable: false },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
      headerComponent: "CustomHeader",
      headerComponentParams: {
        menuIcon: "fa-filter",
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Header component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component/vue3/)

The interface for a custom header component is:

```ts
interface IHeader {
    // Gets called when a new Column Definition has been set for this header.
    // If you handle the refresh of your header return true otherwise return false
    // and the grid will re-create your header from scratch.
    refresh(params: IHeaderParams): boolean;
}
```

When a Vue component is instantiated the grid will make the grid APIs, a number of utility methods as well as the cell and row values available to you via `this.params` - the interface for what is provided is documented below.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

### Responsibilities

The grid provides the following features that should not be implemented by Custom Header Components:

- [**Resizing:**](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-sizing/) When enabled, the grid will put an invisible widget to be grabbed by the mouse for resizing.
- [**Header Checkbox Selection:**](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-selection-multi-row/#selecting-all-rows) When enabled, the grid displays a checkbox for 'select all' in the header.
- **Column Moving** The grid will react to Column Dragging to reorder columns.

The Custom Header Component is responsible for the following:

- **Sorting:** You will need to process user interaction for sorting. The default grid component sorts when the user clicks the header with the mouse. You may also need to display icons as the sort state of the column changes.
- **Filtering:** You do not filter via the column (you filter from inside the menu), however you may need to display icons as the filter state of the column changes.
- **Menu:** If you want the user to be able to open the column menu, you will need to manage this user interaction. The default grid component provides a button for the user to click to show the menu.
- **Anything Else:** Whatever you want, you are probably creating a custom header to add your own functionality in.

### Sorting

How you interact with the user for sorting (e.g. listening for mouse clicks) is up to you. The grid helps you by providing column state and events for getting and setting the sort.

After the user requests a sort, you should call ONE of the following:

1. `params.progressSort(multiSort)`: Call this method to progress the sort on the column to the next stage. This uses the grid logic to determine the next sort stage (eg 'descending' normally follows 'ascending').
2. `params.setSort(direction, multiSort)`: If you don't want to use the grid's logic for working out the next sort state, use this to set the sort to a specific state.

```js
// option 1) tell the grid when you want to progress the sorting
onSortClicked(event) {
     // in this example, we do multi sort if Shift key is pressed
    this.params.progressSort(event.shiftKey);
};

// or option 2) tell the grid when you want to set the sort explicitly
// button that always sorts ASCENDING
onSortAscClicked(event) {
    this.params.setSort('asc', event.shiftKey);
};

// button that always sorts DESCENDING
onSortDescClicked(event) {
    this.params.setSort('desc', event.shiftKey);
};
```

To know when a column's sort state has changed (e.g. when to update your icons), you should listen for the `sortChanged` event on the column.

```js
// listen to the column for sort events
column.addEventListener('sortChanged', function() {

    // get sort state from column
    var sort = column.getSortDef()?.direction;
    console.log('sort state of column is ' + sort); // prints one of ['asc',desc',null]

    // then do what you need, e.g. set relevant icons visible
    var sortingAscending = sort==='asc';
    var sortingDescending = sort==='desc';
    var notSorting = !sortingAscending && !sortingDescending;
    // how you update your GUI accordingly is up to you
});

// don't forget to remove your listener in your destroy code
```

### Filtering

The header doesn't normally initiate filtering. If it does, use the standard grid API to set the filter. The header will typically display icons when the filter is applied. To know when to show a filter icon, listen to the column for `filterChanged` events.

```js
// listen to the column for filter events
column.addEventListener('filterChanged', function() {
    // when filter changes on the col, this will print one of [true,false]
    console.log('filter of column is ' + column.isFilterActive());
});

// don't forget to remove your listener in your destroy code
```

### Menu

How you get the user to ask for the column menu is up to you. When you want to display the menu, call the `params.showColumnMenu()` callback. The callback takes the HTML element for the button so that it can place the menu over the button (so the menu appears to drop down from the button).

```js
onMenuClicked() {
    this.params.showColumnMenu(this.$refs.menuButton);
});
```

### Refreshing Headers

If you are creating your own [Header Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers/) then you will need to be aware of how Header Components are refreshed.

All Header Components that still exist after the new Column Definitions are applied (in other words, the Column still exists after the update, it was not removed) will have its `refresh` method called.

It is the responsibility of the Header Component to inspect the Column Definition for relevant changes and update itself if needed. If the refresh was successful then `true` should be returned. If the refresh was not successful then `false` should be returned. If `false` is returned, then the grid will destroy and recreate the component. This pattern is consistent with the `refresh` method of Cell Renderers.

The example below demonstrates refreshing of the headers. Note the following:

- Each column is configured to use a custom Header Component.
- The Header Component logs to the console when its lifecycle methods/functions are called.
- Toggling between 'Upper Header Names' and 'Lower Header Names' causes the Header Component to refresh.
- Toggling between 'Filter On' and 'Filter Off' causes the Header Component to refresh.
- Toggling between 'Resize On' and 'Resize Off' causes the Header Component to refresh. However there is no change to the Header Component as it doesn't depend on resize - the resize UI is provided by the grid.

#### Refresh Headers

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeaderVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <button v-on:click="onBtUpperNames()">Upper Header Names</button>
        <button v-on:click="onBtLowerNames()">Lower Header Names</button>
        &nbsp;&nbsp;&nbsp;
        <button v-on:click="onBtFilterOn()">Filter On</button>
        <button v-on:click="onBtFilterOff()">Filter Off</button>
        &nbsp;&nbsp;&nbsp;
        <button v-on:click="onBtResizeOn()">Resize On</button>
        <button v-on:click="onBtResizeOff()">Resize Off</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        class="test-grid"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomHeader,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      headerComponent: "CustomHeader",
    });
    const rowData = ref<IOlympicData[]>(null);

    function onBtUpperNames() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.headerName = c.field!.toUpperCase();
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    function onBtLowerNames() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.headerName = c.field;
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    function onBtFilterOn() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.filter = true;
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    function onBtFilterOff() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.filter = false;
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    function onBtResizeOn() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.resizable = true;
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    function onBtResizeOff() {
      const columnDefs: ColDef[] = [
        { field: "athlete" },
        { field: "age" },
        { field: "country" },
        { field: "year" },
        { field: "date" },
        { field: "sport" },
        { field: "gold" },
        { field: "silver" },
        { field: "bronze" },
        { field: "total" },
      ];
      columnDefs.forEach((c) => {
        c.resizable = false;
      });
      gridApi.value!.setGridOption("columnDefs", columnDefs);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onBtUpperNames,
      onBtLowerNames,
      onBtFilterOn,
      onBtFilterOff,
      onBtResizeOn,
      onBtResizeOff,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Refresh Headers](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/refresh-headers/vue3/)

### Custom Props

On top of the props provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the header component. For example, you might have a header component for formatting currency which also requires the currency symbol to be provided.

```js
colDef = {
    ...
    headerComponent: 'MyHeaderComponent';
    headerComponentParams : {
        currencySymbol: '£' // the pound symbol will be placed into params
    }
}
```

### Keyboard Navigation

When using Custom Header Components, the Custom Header Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid header with a Custom Header Component will focus the entire cell instead of any of the elements inside.

Adding support for keyboard navigation and focus requires a custom `suppressHeaderKeyboardEvent` function in grid options. See [Suppress Keyboard Events](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/keyboard-navigation/#suppress-keyboard-events).

An example of this is shown below, enabling keyboard navigation through the custom header elements when pressing `⇥ Tab` and `⇧ Shift`+`⇥ Tab`:

- Click on the top left `Athlete` header, press the `⇥ Tab` key and notice that the button, textbox and link in the `Country` header can be tabbed into. At the end of the cell elements, the tab focus moves to the next `Age` header cell
- Use `⇧ Shift`+`⇥ Tab` to navigate in the reverse direction

The `suppressHeaderKeyboardEvent` callback is used to capture tab events and determine if the user is tabbing forward or backwards. It also suppresses the default behaviour of moving to the next cell if tabbing within the child elements.

If the focus is at the beginning or the end of the cell children and moving out of the cell, the keyboard event is not suppressed, so focus can move between the children elements. Also, when moving backwards, the focus needs to be manually set while preventing the default behaviour of the keyboard press event.

#### Custom Header Keyboard Navigation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SuppressHeaderKeyboardEventParams,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeaderVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([TextFilterModule, ClientSideRowModelModule]);

const GRID_CELL_CLASSNAME = "ag-header-cell";

function getAllFocusableElementsOf(el: HTMLElement) {
  return Array.from<HTMLElement>(
    el.querySelectorAll(
      'button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"])',
    ),
  ).filter((focusableEl) => {
    return focusableEl.tabIndex !== -1;
  });
}

function getEventPath(event: Event): HTMLElement[] {
  const path: HTMLElement[] = [];
  let currentTarget: any = event.target;
  while (currentTarget) {
    path.push(currentTarget);
    currentTarget = currentTarget.parentElement;
  }
  return path;
}

/**
 * Capture whether the user is tabbing forwards or backwards and suppress keyboard event if tabbing
 * outside of the children
 */
function suppressHeaderKeyboardEvent({
  event,
}: SuppressHeaderKeyboardEventParams) {
  const { key, shiftKey } = event;
  const path = getEventPath(event);
  const isTabForward = key === "Tab" && shiftKey === false;
  const isTabBackward = key === "Tab" && shiftKey === true;
  let suppressEvent = false;
  // Handle cell children tabbing
  if (isTabForward || isTabBackward) {
    const eGridCell = path.find((el) => {
      if (el.classList === undefined) return false;
      return el.classList.contains(GRID_CELL_CLASSNAME);
    });
    if (!eGridCell) {
      return suppressEvent;
    }
    const focusableChildrenElements = getAllFocusableElementsOf(eGridCell);
    const lastCellChildEl =
      focusableChildrenElements[focusableChildrenElements.length - 1];
    const firstCellChildEl = focusableChildrenElements[0];
    // Suppress keyboard event if tabbing forward within the cell and the current focused element is not the last child
    if (isTabForward && focusableChildrenElements.length > 0) {
      const isLastChildFocused =
        lastCellChildEl && document.activeElement === lastCellChildEl;
      if (!isLastChildFocused) {
        suppressEvent = true;
      }
    }
    // Suppress keyboard event if tabbing backwards within the cell, and the current focused element is not the first child
    else if (isTabBackward && focusableChildrenElements.length > 0) {
      const cellHasFocusedChildren =
        eGridCell.contains(document.activeElement) &&
        eGridCell !== document.activeElement;
      // Manually set focus to the last child element if cell doesn't have focused children
      if (!cellHasFocusedChildren) {
        lastCellChildEl.focus();
        // Cancel keyboard press, so that it doesn't focus on the last child and then pass through the keyboard press to
        // move to the 2nd last child element
        event.preventDefault();
      }
      const isFirstChildFocused =
        firstCellChildEl && document.activeElement === firstCellChildEl;
      if (!isFirstChildFocused) {
        suppressEvent = true;
      }
    }
  }
  return suppressEvent;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomHeader,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        sortable: false,
      },
      {
        field: "country",
        headerComponent: "CustomHeader",
        minWidth: 270,
        flex: 1,
        sortable: false,
      },
      {
        field: "age",
        sortable: false,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      minWidth: 130,
      flex: 1,
      suppressHeaderKeyboardEvent,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Custom Header Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component-keyboard-navigation/vue3/)

### Dynamic Tooltips

When using Custom Header Components it might be necessary to have a better control of how `Tooltips` are added instead of simply using the `headerTooltip` config. For this purpose, we provide the `setTooltip` method.

Properties available on the `IHeaderParams&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `setTooltip` | `Function` |  |  |  |

The example below demonstrates using the Dynamic Tooltips with a Custom Header Component.

- Note that only Column Headers where the text is not fully displayed will show tooltips.

#### Header Tooltip

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  TooltipModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeaderVue";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  TooltipModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    CustomHeader,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "athlete",
        headerName: "Athlete's Full Name",
        suppressHeaderFilterButton: true,
        minWidth: 120,
      },
      {
        field: "age",
        headerName: "Athlete's Age",
        sortable: false,
        headerComponentParams: { menuIcon: "fa-external-link-alt" },
      },
      {
        field: "country",
        headerName: "Athlete's Country",
        suppressHeaderFilterButton: true,
        minWidth: 120,
      },
      { field: "year", headerName: "Event Year", sortable: false },
      {
        field: "date",
        headerName: "Event Date",
        suppressHeaderFilterButton: true,
      },
      { field: "sport", sortable: false },
      {
        field: "gold",
        headerName: "Gold Medals",
        headerComponentParams: { menuIcon: "fa-cog" },
        minWidth: 120,
      },
      { field: "silver", headerName: "Silver Medals", sortable: false },
      {
        field: "bronze",
        headerName: "Bronze Medals",
        suppressHeaderFilterButton: true,
        minWidth: 120,
      },
      { field: "total", headerName: "Total Medals", sortable: false },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
      width: 120,
      headerComponent: "CustomHeader",
      headerComponentParams: {
        menuIcon: "fa-bars",
      },
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        rowData.value = data;
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Header Tooltip](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/dynamic-tooltips/vue3/)

### Touch Support

See the [Touch](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/touch/) documentation for how the grid will handle touch support, particularly for [Touch Events](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/touch/#custom-header-components).


---
product: "AG Grid"
title: "Column Headers - Custom Components"
description: "Create Custom Header Components for the React Table. Customise header templates, create inner header components, and implement full custom headers with sorting, filtering and menu support."
framework: react
version: "36.2.0"
related:
    - title: "Styling & Height"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers-styling/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column Headers - Custom Components

The grid provides a default Header Component with sorting, filtering and menu functionality. There are three approaches to customising Column Headers:

- [Custom Template](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers-components/#custom-template) - Provide an HTML template to the default Header Component for simple layout changes while retaining built-in functionality.
- [Inner Header Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers-components/#inner-header-component) - Replace just the header name display with a custom component while keeping sorting, filtering and menu functionality.
- [Custom Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers-components/#custom-component) - Create a fully custom Header Component with complete control over rendering and behaviour.

## Custom Template

Provide an HTML template to the Provided Header Component for simple layout changes while retaining built-in sorting, filtering and menu functionality.

Set the template using `colDef.headerComponentParams`. Set on the `defaultColDef` grid option to set for all Columns.

```jsx
const defaultColDef = useMemo(() => { 
	return {
        width: 100,
        headerComponentParams: {
            template:
                `<div class="ag-cell-label-container" role="presentation">
                  <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                  <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                  <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                    <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order"></span>
                    <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon"></span>
                    <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon"></span>
                    <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon"></span>
                    <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon"></span>
                    <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon"></span>
                    <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon"></span>
                    ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                    <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                  </div>
                </div>`
        }
    };
}, []);

<AgGridReact defaultColDef={defaultColDef} />
```

The example below demonstrates a custom template. Note that specifying your own templates is compatible with other configurations:

- `suppressHeaderFilterButton` is specified in: **Athlete**, **Country**, **Date** and **Bronze** columns
- `sortable=false` is specified in: **Age**, **Year**, **Date**, **Sport**, **Silver** and **Total** columns
- **Gold** is the only column that doesn't have `sortable=false` or `suppressHeaderFilterButton`

#### Header template

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicData[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      headerName: "Athlete Name",
      field: "athlete",
      suppressHeaderFilterButton: true,
    },
    { field: "age", sortable: false },
    { field: "country", suppressHeaderFilterButton: true },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true, sortable: false },
    { field: "sport", sortable: false },
    { field: "gold" },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true },
    { field: "total", sortable: false },
    { field: "prevYearTotalDiff", sort: { type: "absolute", direction: null } },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      width: 150,
      headerComponentParams: {
        template: `<div class="ag-cell-label-container" role="presentation">
                    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button"></span>
                    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button"></span>
                    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
                        <span data-ref="eSortOrder" class="ag-header-icon ag-sort-order ag-hidden"></span>
                        <span data-ref="eSortAsc" class="ag-header-icon ag-sort-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortDesc" class="ag-header-icon ag-sort-descending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
                        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-sort-absolute-descending-icon ag-hidden"></span>
                        <span data-ref="eSortMixed" class="ag-header-icon ag-sort-mixed-icon ag-hidden"></span>
                        <span data-ref="eSortNone" class="ag-header-icon ag-sort-none-icon ag-hidden"></span>
                        ** <span data-ref="eText" class="ag-header-cell-text" role="columnheader"></span>
                        <span data-ref="eFilter" class="ag-header-icon ag-filter-icon"></span>
                    </div>
                </div>`,
      },
    };
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicData[]) =>
        setRowData(
          data.map((d) => ({
            ...d,
            prevYearTotalDiff: Math.floor(
              (2 * window.agRandom() - 1) * d.total,
            ),
          })),
        ),
      );
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            onGridReady={onGridReady}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Header template](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-template/reactFunctionalTs/)

### Default Template

This is the default template used in AG Grid:

```html
<div class="ag-cell-label-container" role="presentation">
    <span data-ref="eMenu" class="ag-header-icon ag-header-cell-menu-button" aria-hidden="true"></span>
    <span data-ref="eFilterButton" class="ag-header-icon ag-header-cell-filter-button" aria-hidden="true"></span>
    <div data-ref="eLabel" class="ag-header-cell-label" role="presentation">
        <span data-ref="eText" class="ag-header-cell-text"></span>
        <span data-ref="eFilter" class="ag-header-icon ag-header-label-icon ag-filter-icon" aria-hidden="true"></span>
        <span data-ref="eSortOrder" class="ag-header-icon ag-header-label-icon ag-sort-order" aria-hidden="true"></span>
        <span data-ref="eSortAsc" class="ag-header-icon ag-header-label-icon ag-sort-ascending-icon" aria-hidden="true"></span>
        <span data-ref="eSortDesc" class="ag-header-icon ag-header-label-icon ag-sort-descending-icon" aria-hidden="true"></span>
        <span data-ref="eSortAbsoluteAsc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-ascending-icon ag-hidden"></span>
        <span data-ref="eSortAbsoluteDesc" class="ag-header-icon ag-header-label-icon ag-sort-absolute-descending-icon ag-hidden"></span>
        <span data-ref="eSortMixed" class="ag-header-icon ag-header-label-icon ag-sort-mixed-icon ag-hidden"></span>
        <span data-ref="eSortNone" class="ag-header-icon ag-header-label-icon ag-sort-none-icon" aria-hidden="true"></span>
    </div>
</div>
```

When you provide your own template, everything should work as expected as long as you re-use the same `data-ref` attribute names.

| Ref | Description |
| --- | --- |
| `eMenu` | The container where the column menu icon will appear to enable opening the column menu (in AG Grid Community, this is only used when `columnMenu = 'legacy'`). |
| `eFilterButton` | The container where the column filter icon will appear to enable opening the filter (not used when `columnMenu = 'legacy'`). |
| `eLabel` | The container where there is going to be an onClick mouse listener to trigger the sort. |
| `eText` | The text displayed on the column. |
| `eFilter` | The container with the icon that will appear if the user filters this column (only used when `columnMenu = 'legacy'` or `suppressHeaderFilterButton = true`). |
| `eSortOrder` | If multiple columns are sorted, this shows the index that represents the position of this column in the order. |
| `eSortAsc` | If the column is sorted ascending, this shows the ascending icon. |
| `eSortDesc` | If the column is sorted descending, this shows the descending icon. |
| `eSortAbsoluteAsc` | If the column is sorted absolute ascending, this shows the absolute ascending icon. |
| `eSortAbsoluteDesc` | If the column is sorted absolute descending, this shows the absolute descending icon. |
| `eSortMixed` | If the column has a mixed sort state (e.g. grouped data with differing sort directions), this shows the mixed sort icon. |
| `eSortNone` | If no sort is applied, this shows the no sort icon. Note this icon by default is empty. |

The `data-ref` parameters are used by the grid to identify elements to add functionality to. If you leave an element out of your template, the functionality will not be added. For example if you do not specify `eLabel` then the column will not react to click events for sorting.

> **Note**
>
> Templates are not meant to let you configure icons. If you are looking to change the icons, see [Custom Icons](https://www.ag-grid.com/archive/36.2.0/react-data-grid/custom-icons/) for more information.

## Inner Header Component

When using the Header Component, the `agColumnHeader` component will display the header name, adjacent to any configured menu, filter, and checkbox.

This text value can be overridden with a [Custom Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/components/) by setting the `innerHeaderComponent` and `innerHeaderComponentParams` properties on the `headerComponentParams` property. This is useful when you only need to implement a Component to customise the **Column Name** without having to reimplement the whole header functionality (sorting, filter, menu, etc...).

```js
colDef = {
    ...
    headerComponentParams : {
        innerHeaderComponent: MyInnerHeaderComponent,
        innerHeaderComponentParams: {
            currencySymbol: '£' // the pound symbol will be placed into params
        }
    }
}
```

#### Custom Inner Header Component

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomInnerHeader from "./customInnerHeader.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
    {
      field: "age",
      sortable: false,
      headerComponentParams: {
        icon: "fa-user",
      },
    },
    { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerComponentParams: { icon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "total", sortable: false },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
      headerComponentParams: {
        innerHeaderComponent: CustomInnerHeader,
      },
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Inner Header Component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/inner-header-component/reactFunctionalTs/)

```ts
const CustomInnerHeaderComponent = (props: CustomInnerHeaderProps) => {
    return <div>{props.displayName}</div>;
};
```

The following props are passed to the Custom Component (`CustomInnerHeaderProps` interface).

### CustomInnerHeaderProps

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `template` | `string` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

## Custom Component

To use a fully customised Header Component, set `headerComponent` on the Column Definition to the custom component. See [Registering Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/components/) for an overview.

```js
// a list of column definitions
const colDefs = [

    // no Header Comp specified, uses the Provided Header Comp
    {headerName: "Athlete", field: "athlete"},
    {headerName: "Sport", field: "sport"},

    // uses Custom Header Comp
    {headerName: "Age", field: "age", headerComponent: MyHeaderComponent}
]
```

- Column moving and resizing works without custom logic.
- `suppressHeaderFilterButton=true` is used to suppress the filter menu.
- `sortable=false` is used to suppress sorting.
- The menu icon is configurable.

#### Header component

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeader.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", suppressHeaderFilterButton: true, minWidth: 120 },
    {
      field: "age",
      sortable: false,
      headerComponentParams: { menuIcon: "fa-external-link-alt" },
    },
    { field: "country", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "year", sortable: false },
    { field: "date", suppressHeaderFilterButton: true },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerComponentParams: { menuIcon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", sortable: false },
    { field: "bronze", suppressHeaderFilterButton: true, minWidth: 120 },
    { field: "total", sortable: false },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
      filter: true,
      headerComponent: CustomHeader,
      headerComponentParams: {
        menuIcon: "fa-filter",
      },
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Header component](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component/reactFunctionalTs/)

The following props are passed to the Custom Component (`CustomHeaderProps` interface).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `column` | `Column` |  |  |  |
| `displayName` | `string` |  |  |  |
| `enableSorting` | `boolean \| undefined` |  |  |  |
| `enableMenu` | `boolean` |  |  |  |
| `enableFilterButton` | `boolean` |  |  |  |
| `enableFilterIcon` | `boolean` |  |  |  |
| `showColumnMenu` | `Function` |  |  |  |
| `showColumnMenuAfterMouseClick` | `Function` |  |  |  |
| `showFilter` | `Function` |  |  |  |
| `progressSort` | `Function` |  |  |  |
| `setSort` | `Function` |  |  |  |
| `innerHeaderComponent` | `any` |  |  |  |
| `innerHeaderComponentParams` | `any` |  |  |  |
| `eGridHeader` | `HTMLElement` |  |  |  |
| `setTooltip` | `Function` |  |  |  |
| `api` | `GridApi` |  |  |  |
| `context` | `TContext` |  |  |  |

### Responsibilities

The grid provides the following features that should not be implemented by Custom Header Components:

- [**Resizing:**](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-sizing/) When enabled, the grid will put an invisible widget to be grabbed by the mouse for resizing.
- [**Header Checkbox Selection:**](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-selection-multi-row/#selecting-all-rows) When enabled, the grid displays a checkbox for 'select all' in the header.
- **Column Moving** The grid will react to Column Dragging to reorder columns.

The Custom Header Component is responsible for the following:

- **Sorting:** You will need to process user interaction for sorting. The default grid component sorts when the user clicks the header with the mouse. You may also need to display icons as the sort state of the column changes.
- **Filtering:** You do not filter via the column (you filter from inside the menu), however you may need to display icons as the filter state of the column changes.
- **Menu:** If you want the user to be able to open the column menu, you will need to manage this user interaction. The default grid component provides a button for the user to click to show the menu.
- **Anything Else:** Whatever you want, you are probably creating a custom header to add your own functionality in.

### Sorting

How you interact with the user for sorting (e.g. listening for mouse clicks) is up to you. The grid helps you by providing column state and events for getting and setting the sort.

After the user requests a sort, you should call ONE of the following:

1. `props.progressSort(multiSort)`: Call this method to progress the sort on the column to the next stage. This uses the grid logic to determine the next sort stage (eg 'descending' normally follows 'ascending').
2. `props.setSort(direction, multiSort)`: If you don't want to use the grid's logic for working out the next sort state, use this to set the sort to a specific state.

```js
// option 1) tell the grid when you want to progress the sorting
onSortClicked(event) {
     // in this example, we do multi sort if Shift key is pressed
    props.progressSort(event.shiftKey);
};

// or option 2) tell the grid when you want to set the sort explicitly
// button that always sorts ASCENDING
onSortAscClicked(event) {
    props.setSort('asc', event.shiftKey);
};

// button that always sorts DESCENDING
onSortDescClicked(event) {
    props.setSort('desc', event.shiftKey);
};
```

To know when a column's sort state has changed (e.g. when to update your icons), you should listen for the `sortChanged` event on the column.

```js
// listen to the column for sort events
column.addEventListener('sortChanged', function() {

    // get sort state from column
    var sort = column.getSortDef()?.direction;
    console.log('sort state of column is ' + sort); // prints one of ['asc',desc',null]

    // then do what you need, e.g. set relevant icons visible
    var sortingAscending = sort==='asc';
    var sortingDescending = sort==='desc';
    var notSorting = !sortingAscending && !sortingDescending;
    // how you update your GUI accordingly is up to you
});

// don't forget to remove your listener in your destroy code
```

### Filtering

The header doesn't normally initiate filtering. If it does, use the standard grid API to set the filter. The header will typically display icons when the filter is applied. To know when to show a filter icon, listen to the column for `filterChanged` events.

```js
// listen to the column for filter events
column.addEventListener('filterChanged', function() {
    // when filter changes on the col, this will print one of [true,false]
    console.log('filter of column is ' + column.isFilterActive());
});

// don't forget to remove your listener in your destroy code
```

### Menu

How you get the user to ask for the column menu is up to you. When you want to display the menu, call the `params.showColumnMenu()` callback. The callback takes the HTML element for the button so that it can place the menu over the button (so the menu appears to drop down from the button).

```js
onMenuClicked() {
    props.showColumnMenu(refButton.current);
});
```

### Refreshing Headers

If you are creating your own [Header Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers/) then you will need to be aware of how Header Components are refreshed.

All Header Components that still exist after the new Column Definitions are applied (in other words, the Column still exists after the update, it was not removed) will be re-rendered.

It is up to the Header Component to update based on any changes it may find in the Column Definition.

The example below demonstrates refreshing of the headers. Note the following:

- Each column is configured to use a custom Header Component.
- The Header Component logs to the console when its lifecycle methods/functions are called.
- Toggling between 'Upper Header Names' and 'Lower Header Names' causes the Header Component to refresh.
- Toggling between 'Filter On' and 'Filter Off' causes the Header Component to refresh.
- Toggling between 'Resize On' and 'Resize Off' causes the Header Component to refresh. However there is no change to the Header Component as it doesn't depend on resize - the resize UI is provided by the grid.

#### Refresh Headers

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeader.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "year" },
    { field: "date" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      headerComponent: CustomHeader,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onBtUpperNames = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.headerName = c.field!.toUpperCase();
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  const onBtLowerNames = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.headerName = c.field;
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  const onBtFilterOn = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.filter = true;
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  const onBtFilterOff = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.filter = false;
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  const onBtResizeOn = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.resizable = true;
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  const onBtResizeOff = useCallback(() => {
    const columnDefs: ColDef[] = [
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "year" },
      { field: "date" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ];
    columnDefs.forEach((c) => {
      c.resizable = false;
    });
    gridRef.current!.api.setGridOption("columnDefs", columnDefs);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <button onClick={onBtUpperNames}>Upper Header Names</button>
            <button onClick={onBtLowerNames}>Lower Header Names</button>
            &nbsp;&nbsp;&nbsp;
            <button onClick={onBtFilterOn}>Filter On</button>
            <button onClick={onBtFilterOff}>Filter Off</button>
            &nbsp;&nbsp;&nbsp;
            <button onClick={onBtResizeOn}>Resize On</button>
            <button onClick={onBtResizeOff}>Resize Off</button>
          </div>

          <div style={gridStyle} className="test-grid">
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Refresh Headers](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/refresh-headers/reactFunctionalTs/)

### Custom Props

On top of the props provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the header component. For example, you might have a header component for formatting currency which also requires the currency symbol to be provided.

```js
colDef = {
    ...
    headerComponent: MyHeaderComponent;
    headerComponentParams : {
        currencySymbol: '£' // the pound symbol will be placed into params
    }
}
```

### Keyboard Navigation

When using Custom Header Components, the Custom Header Component is responsible for implementing support for keyboard navigation among its focusable elements. This is why by default, focusing a grid header with a Custom Header Component will focus the entire cell instead of any of the elements inside.

Adding support for keyboard navigation and focus requires a custom `suppressHeaderKeyboardEvent` function in grid options. See [Suppress Keyboard Events](https://www.ag-grid.com/archive/36.2.0/react-data-grid/keyboard-navigation/#suppress-keyboard-events).

An example of this is shown below, enabling keyboard navigation through the custom header elements when pressing `⇥ Tab` and `⇧ Shift`+`⇥ Tab`:

- Click on the top left `Athlete` header, press the `⇥ Tab` key and notice that the button, textbox and link in the `Country` header can be tabbed into. At the end of the cell elements, the tab focus moves to the next `Age` header cell
- Use `⇧ Shift`+`⇥ Tab` to navigate in the reverse direction

The `suppressHeaderKeyboardEvent` callback is used to capture tab events and determine if the user is tabbing forward or backwards. It also suppresses the default behaviour of moving to the next cell if tabbing within the child elements.

If the focus is at the beginning or the end of the cell children and moving out of the cell, the keyboard event is not suppressed, so focus can move between the children elements. Also, when moving backwards, the focus needs to be manually set while preventing the default behaviour of the keyboard press event.

#### Custom Header Keyboard Navigation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SuppressHeaderKeyboardEventParams,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeader.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [TextFilterModule, ClientSideRowModelModule];

const GRID_CELL_CLASSNAME = "ag-header-cell";

function getAllFocusableElementsOf(el: HTMLElement) {
  return Array.from<HTMLElement>(
    el.querySelectorAll(
      'button, [href], input, select, textarea, [tabindex]:not([tabindex="-1"])',
    ),
  ).filter((focusableEl) => {
    return focusableEl.tabIndex !== -1;
  });
}

const getEventPath: (event: Event) => HTMLElement[] = (event: Event) => {
  const path: HTMLElement[] = [];
  let currentTarget: any = event.target;
  while (currentTarget) {
    path.push(currentTarget);
    currentTarget = currentTarget.parentElement;
  }
  return path;
};

/**
 * Capture whether the user is tabbing forwards or backwards and suppress keyboard event if tabbing
 * outside of the children
 */
function suppressHeaderKeyboardEvent({
  event,
}: SuppressHeaderKeyboardEventParams) {
  const { key, shiftKey } = event;
  const path = getEventPath(event);
  const isTabForward = key === "Tab" && shiftKey === false;
  const isTabBackward = key === "Tab" && shiftKey === true;
  let suppressEvent = false;
  // Handle cell children tabbing
  if (isTabForward || isTabBackward) {
    const eGridCell = path.find((el) => {
      if (el.classList === undefined) return false;
      return el.classList.contains(GRID_CELL_CLASSNAME);
    });
    if (!eGridCell) {
      return suppressEvent;
    }
    const focusableChildrenElements = getAllFocusableElementsOf(eGridCell);
    const lastCellChildEl =
      focusableChildrenElements[focusableChildrenElements.length - 1];
    const firstCellChildEl = focusableChildrenElements[0];
    // Suppress keyboard event if tabbing forward within the cell and the current focused element is not the last child
    if (isTabForward && focusableChildrenElements.length > 0) {
      const isLastChildFocused =
        lastCellChildEl && document.activeElement === lastCellChildEl;
      if (!isLastChildFocused) {
        suppressEvent = true;
      }
    }
    // Suppress keyboard event if tabbing backwards within the cell, and the current focused element is not the first child
    else if (isTabBackward && focusableChildrenElements.length > 0) {
      const cellHasFocusedChildren =
        eGridCell.contains(document.activeElement) &&
        eGridCell !== document.activeElement;
      // Manually set focus to the last child element if cell doesn't have focused children
      if (!cellHasFocusedChildren) {
        lastCellChildEl.focus();
        // Cancel keyboard press, so that it doesn't focus on the last child and then pass through the keyboard press to
        // move to the 2nd last child element
        event.preventDefault();
      }
      const isFirstChildFocused =
        firstCellChildEl && document.activeElement === firstCellChildEl;
      if (!isFirstChildFocused) {
        suppressEvent = true;
      }
    }
  }
  return suppressEvent;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      sortable: false,
    },
    {
      field: "country",
      headerComponent: CustomHeader,
      minWidth: 270,
      flex: 1,
      sortable: false,
    },
    {
      field: "age",
      sortable: false,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      minWidth: 130,
      flex: 1,
      suppressHeaderKeyboardEvent,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Custom Header Keyboard Navigation](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/header-component-keyboard-navigation/reactFunctionalTs/)

### Dynamic Tooltips

When using Custom Header Components it might be necessary to have a better control of how `Tooltips` are added instead of simply using the `headerTooltip` config. For this purpose, we provide the `setTooltip` method.

Properties available on the `CustomHeaderProps&lt;TData = any, TContext = any&gt;` interface.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `setTooltip` | `Function` |  |  |  |

The example below demonstrates using the Dynamic Tooltips with a Custom Header Component.

- Note that only Column Headers where the text is not fully displayed will show tooltips.

#### Header Tooltip

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  NumberFilterModule,
  TextEditorModule,
  TextFilterModule,
  TooltipModule,
  enableDevValidations,
} from "ag-grid-community";
import CustomHeader from "./customHeader.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  TextFilterModule,
  NumberFilterModule,
  ClientSideRowModelModule,
  TooltipModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "athlete",
      headerName: "Athlete's Full Name",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    {
      field: "age",
      headerName: "Athlete's Age",
      sortable: false,
      headerComponentParams: { menuIcon: "fa-external-link-alt" },
    },
    {
      field: "country",
      headerName: "Athlete's Country",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    { field: "year", headerName: "Event Year", sortable: false },
    {
      field: "date",
      headerName: "Event Date",
      suppressHeaderFilterButton: true,
    },
    { field: "sport", sortable: false },
    {
      field: "gold",
      headerName: "Gold Medals",
      headerComponentParams: { menuIcon: "fa-cog" },
      minWidth: 120,
    },
    { field: "silver", headerName: "Silver Medals", sortable: false },
    {
      field: "bronze",
      headerName: "Bronze Medals",
      suppressHeaderFilterButton: true,
      minWidth: 120,
    },
    { field: "total", headerName: "Total Medals", sortable: false },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      filter: true,
      width: 120,
      headerComponent: CustomHeader,
      headerComponentParams: {
        menuIcon: "fa-bars",
      },
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Header Tooltip](https://www.ag-grid.com/archive/36.2.0/examples/column-headers-components/dynamic-tooltips/reactFunctionalTs/)

### Touch Support

See the [Touch](https://www.ag-grid.com/archive/36.2.0/react-data-grid/touch/) documentation for how the grid will handle touch support, particularly for [Touch Events](https://www.ag-grid.com/archive/36.2.0/react-data-grid/touch/#custom-header-components).
